/* Lesson 6 INLINE Code */


-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
----Lesson 6.1 Correlated Subquery---------------------------

Use AdventureWorks2012
GO

SELECT CustomerID, SalesOrderID, OrderDate
FROM Sales.SalesOrderHeader AS outersoh
WHERE OrderDate = 
	(SELECT Max(OrderDate)
	FROM Sales.SalesOrderHeader AS innersoh
	WHERE innersoh.CustomerID = outersoh.CustomerID)
ORDER BY CustomerID

-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
-----Lesson 6.1 Self-Contained Scalar Subquery-------------
Use AdventureWorks2012
GO

SELECT ProductID, Name, ListPrice
FROM Production.Product
WHERE ListPrice = 
	(SELECT MAX(ListPrice)
	FROM Production.Product);

-->>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
-----Lesson 6.1 Self-Contained Multi-Valued Subquery-------
--MULTI-VALUED SUBQUERY --
--RETURNS MULTIPLE VALUES AS A SINGLE COLUMN SET TO THE OUTER QUERY --

Use AdventureWorks2012
GO

--THE INNER QUERY EXECUTES ON THE Sales.SalesTerritory TABLE --
--select * from sales.SalesTerritory

/*SELECT TerritoryID
	FROM Sales.SalesTerritory
	WHERE CountryRegionCode = N'GB'
*/


--SELECT THE CUSTOMERIDS AND THEIR ACCOUNTNUMBERS FROM THE UNITED KINGDOM -- 
SELECT CustomerID, AccountNumber, TerritoryID
FROM Sales.Customer
--USED WITH THE IN PREDICATE --
--IF VALUES IN THE SUB-QUERY MATCH THE IN PREDICATE, THEY ARE RETURNED TO THE OUTER QUERY --
WHERE TerritoryID IN (
	SELECT TerritoryID
	FROM Sales.SalesTerritory
	WHERE CountryRegionCode = N'GB')
